//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 10
// mpm projectile vs end-holded wall
template<class T> void Function_10(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    e.Add_Walls(-1,MPM::BC_SEP,.3,.1*e.m,false);
    e.Add_Collision_Object(RANGE<TV>(TV(.45,.75),TV(.65,.85))*e.m,MPM::BC_NOSLIP,0);
    e.Add_Collision_Object(RANGE<TV>(TV(.45,.15),TV(.65,.25))*e.m,MPM::BC_NOSLIP,0);
    {SPHERE<TV> sphere(TV(.2,.5)*e.m,.06*e.m);
        T density=2*e.unit_rho*e.scale_mass;
        e.Seed_Particles(sphere,[&e](const TV& X){return TV(1,0)*(e.m/e.s);},0,
            density,e.particles_per_cell,r0);
        ARRAY<int> foo(IDENTITY_ARRAY<>(e.particles.number));
        e.Add_Fixed_Corotated(20*e.unit_p*e.scale_E,0.3,&foo);}
    int N_sphere_particles=e.particles.number;
    {RANGE<TV> box(TV(.5,.2)*e.m,TV(.6,.8)*e.m);
        T density=1*e.unit_rho*e.scale_mass;
        e.Seed_Particles(box,0,0,density,e.particles_per_cell,r0);
        int N_box_particles=e.particles.number-N_sphere_particles;
        ARRAY<int> foo(N_box_particles);
        for(int k=0;k<foo.m;k++) foo(k)=k+N_sphere_particles;
        e.Add_Fixed_Corotated(1*e.unit_p*e.scale_E,0.3,&foo);}

    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
}
template void Function_10(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_10(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
