//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 106
template<class T> void Function_106(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
//single particle bouncing -use_reflect only for boundary how to bounce object?
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    e.Add_Walls(-1,MPM::BC_SEP,.2,0,false);
    T density = 2*e.unit_rho*e.scale_mass;
    T volume=e.grid.dX.Product()/e.particles_per_cell;
    T mass=density*volume;
    e.Add_Particle(TV(.5,.5),[](const TV& X){return TV(1,0);},0,mass,volume,r0);
    e.Add_Fixed_Corotated(1e3*e.unit_p*e.scale_E,0.3);
    // fluid flow through static object. square round
}
template void Function_106(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_106(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
