//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 107
template<class T> void Function_107(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m,IV(1,1));

    SPHERE<TV> collobj(SPHERE<TV>(TV(0.5,0.5)*e.m,0.1*e.m));
    T E=1e4*e.unit_p*e.scale_E,nu=.3;
    T density=(T)2200*e.unit_rho*e.scale_mass; // why 2200
    TV gravity=TV(0,0);
    e.Add_Drucker_Prager_Case(E,nu,2);
    e.Add_Source(TV((T)0.9*e.m,(T)0.5*e.m),TV(-1,0),.1*e.m/2,4*e.m/e.s,gravity,density,
        E,nu,0,FLT_MAX,r0);
    e.Add_Collision_Object(collobj,MPM::BC_SLIP,0);
    // e.Add_Walls(-1,MPM::BC_SEP,1,0,false);

}
template void Function_107(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_107(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
