//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 119
// coffee with cream top
template<class T> void Function_119(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m);
    T density = 2*e.unit_rho*e.scale_mass;
    RANGE<TV> coffee(e.grid.domain.min_corner,TV(1,0));
    RANGE<TV> oil(TV(-1,0),TV(1,0.5));
    e.Seed_Particles(coffee,0,0,density,e.particles_per_cell,r0);
    ARRAY_VIEW<VECTOR<T,3> >* colors=e.particles.template Get_Array<VECTOR<T,3> >("color");
    int last = 0;
    for(int i=0; i<e.particles.X.m; i++){
        (*colors)(i)=VECTOR<T,3>(0.4,0,0.1);
        last = i;}

    e.Seed_Particles(oil,0,0,density/10,e.particles_per_cell,r0);
    for(int i=last; i<e.particles.X.m; i++){
        (*colors)(i)=VECTOR<T,3>(0.7,0.4,0.6);
    }
    e.Add_Fixed_Corotated(1e3*e.unit_p*e.scale_E,0.3);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
    e.Add_Walls(-1,MPM::BC_SEP,.2,e.grid.dX(0),false);
    e.opt.dilation_only=true;
    e.particles.mu*=0;
    e.particles.mu0*=0;

}
template void Function_119(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_119(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
