//#####################################################################
// Copyright 2021, Song Bai, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 128c
template<class T> void Function_128c(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m);
    T density=1000*e.unit_rho*e.scale_mass;
    T v_collision=0.2;
    e.Add_Collision_Object(RANGE<TV>(TV(-.15,-.15),TV(.15,.15))*e.m,MPM::BC_NOSLIP,0.1
        , [v_collision](T time){return FRAME<TV>(TV(0,v_collision*time));},
        [v_collision](T time){return TWIST<TV>(TV(0,v_collision),typename TV::SPIN(0));});
    e.Seed_Particles(RANGE<TV>(TV(0,-0.1)*e.m,TV(0.5,0.1)*e.m),[](TV x){return TV(0.2,0);},0,density,e.particles_per_cell,r0);
    e.Add_Fixed_Corotated(1000*e.unit_p*e.scale_E,0.49);
    e.Add_Walls(-1,MPM::BC_SLIP,.2,e.grid.dX(0),false);
}
template void Function_128c(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_128c(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
