//#####################################################################
// Copyright 2021, Song Bai, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 128f
// Test more twist
// TODO view res
template<class T> void Function_128d(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m);
    T density=100*e.unit_rho*e.scale_mass;
    T rot_col=0.1*M_PI;
    e.Add_Collision_Object(RANGE<TV>(TV(-.15,-.15)-TV(-0.5,0),TV(.15,.15)-TV(-0.5,0))*e.m,MPM::BC_NOSLIP,1
        , [&e,rot_col](T time){return FRAME<TV>(ROTATION<TV>::From_Angle(rot_col*time));},
        [&e,rot_col](T time){return TWIST<TV>(TV(),typename TV::SPIN(rot_col));}); // rotating collision object
    e.Add_Collision_Object(RANGE<TV>(TV(-.15,-.15)-TV(+0.5,0),TV(.15,.15)-TV(+0.5,0))*e.m,MPM::BC_NOSLIP,1
        , [&e,rot_col](T time){return FRAME<TV>(ROTATION<TV>::From_Angle(rot_col*time));},
        [&e,rot_col](T time){return TWIST<TV>(TV(),typename TV::SPIN(rot_col));}); // rotating collision object
    e.Seed_Particles(RANGE<TV>(TV(-0.5,-0.05)*e.m,TV(0.5,0.05)*e.m),0,0,density,e.particles_per_cell,r0);
    e.Add_Fixed_Corotated(10*e.unit_p*e.scale_E,0.4);
    e.Add_Walls(-1,MPM::BC_SLIP,0.2,0,false);
}
template void Function_128d(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_128d(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
