//#####################################################################
// Copyright 2021, Song Bai, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 131
// mimic failed case 115b SS-FAIL ./mpm 131 -explicit
template<class T> void Function_131(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    // TODO
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m);
    T density=1010*e.unit_rho*e.scale_mass;
    T volume=e.grid.dX.Product()/e.particles_per_cell;
    T mass=density*volume;
    T j=-.5*e.grid.dX(0);
// T a = e.random.Get_Uniform_Number(-0.4,0.4)/10;
        // T b = e.random.Get_Uniform_Number(-0.4,0.4)/10;
    // T a=1e-3,b=1e-3;
    T a=1,b=1;
    e.Add_Particle(TV(j,0),[a,b](const TV& ){return TV(a,b);},0,mass,volume,r0);
    j+=e.grid.dX(0);
    e.Add_Particle(TV(j,0),[a,b](const TV& ){return -TV(a,b);},0,mass,volume,r0);

    
    e.Add_Neo_Hookean(0.073e9*e.unit_p*e.scale_E,0.4);
    e.Add_Walls(-1,MPM::BC_SLIP,0.01,e.grid.dX.Min()*e.m,false);
}
template void Function_131(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_131(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
