//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 21
// circle with random initial velocities
template<class T> void Function_21(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>(TV(-3,-3),TV(4,4))*e.m);
    SPHERE<TV> sphere(TV(.5,.5)*e.m,.3*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(sphere,0,0,density,e.particles_per_cell,r0);
    e.random.Fill_Uniform(e.particles.V,-1*(e.m/e.s),1*(e.m/e.s));
    e.Add_Fixed_Corotated(1e3*e.unit_p*e.scale_E,0.3);
}
template void Function_21(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_21(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
