//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 24
// (fluid test) circle drop
template<class T> void Function_24(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    // one: ./mpm -kkt -scale_E 0
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    SPHERE<TV> sphere(TV(.5,.7)*e.m,.2*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(sphere,0,0,density,e.particles_per_cell,r0);
    e.Add_Fixed_Corotated(1e3*e.unit_p*e.scale_E,0.3);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
}
template void Function_24(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_24(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
