//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 28
// newton convergence problem: ./mpm 28 -affine -max_dt 1e-3 | grep converge
template<class T> void Function_28(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    e.Add_Collision_Object(RANGE<TV>(TV(-5,-5),TV(5,.1))*e.m,MPM::BC_SLIP,0);
    e.Add_Collision_Object(RANGE<TV>(TV(-5,-5),TV(.1,5))*e.m,MPM::BC_SLIP,0);
    RANGE<TV> box(TV(.21,.21)*e.m,TV(.6,.5)*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(box,0,0,density,e.particles_per_cell,r0);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
    e.Add_Fixed_Corotated(1.71*e.unit_p*e.scale_E,0.4);
}
template void Function_28(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_28(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
