//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 68
// Source test
template<class T> void Function_68(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m,IV(1,1));
    T E=1e4*e.unit_p*e.scale_E,nu=.3;
    T density=(T)2200*e.unit_rho*e.scale_mass;
    TV gravity=TV(0,-9.8*e.m/(e.s*e.s));
    e.Add_Drucker_Prager_Case(E,nu,2);
    e.Add_Source(TV((T)0.5*e.m,0.9*e.m),TV(0,-1),.05*e.m/2,.4*e.m/e.s,gravity,density,
        E,nu,0,FLT_MAX,r0);
    e.Add_Source(TV((T)0.9*e.m,(T)0.5*e.m),TV(-1,0),.1*e.m/2,4*e.m/e.s,gravity,density,
        E,nu,0,FLT_MAX,r0);
    e.Add_Source(TV((T)0.2*e.m,(T)0.2*e.m),TV((T).4,(T).6),.05*e.m/2,3*e.m/e.s,gravity,
        density,E,nu,0,FLT_MAX,r0);
    e.Add_Gravity(gravity);
    e.Add_Walls(-1,MPM::BC_SEP,.3,.1*e.m,false);

}
template void Function_68(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_68(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
