//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 75
// Single Particel Stability Test
template<class T> void Function_75(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    T volume=e.grid.dX.Product()/e.particles_per_cell;
    T mass=density*volume;
    e.Add_Particle(TV(.52,.543),0,0,mass,volume,r0);
    MATRIX<T,2> m;
    e.random.Fill_Uniform(m,-.1,.1);
    e.particles.F.Fill(m+1);
    T E=1e2*e.unit_p*e.scale_E;
    T nu=.3;
    e.Add_Neo_Hookean(E,nu);

}
template void Function_75(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_75(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
