//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 8
// collision an elastic cylinder (TODO: fix description.)
template<class T> void Function_8(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>(TV(),TV(5,5))*e.m,IV()+1,IV()+9,1,32);
    e.Add_Walls(-1,MPM::BC_SEP,.3,.1*e.m,false);
    e.Add_Collision_Object(SPHERE<TV>(TV(4,3)*e.m,1*e.m),MPM::BC_SEP,.3);
    SPHERE<TV> sphere(TV(2.55,3.55)*e.m,.3*e.m);
    T density=4*e.unit_rho*e.scale_mass;
    e.Seed_Particles(sphere,[&e](const TV& X){return TV(3.0*(e.m/e.s),0);},0,
        density,e.particles_per_cell,r0);
    e.Add_Neo_Hookean(e.unit_p*e.scale_E,0.425);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
}
template void Function_8(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_8(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
