//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 80
// smash box between domain boundaries
template<class T> void Function_80(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.reflection_bc=true;
    e.use_full_reflection=true;
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(e.grid.domain,0,0,density,e.particles_per_cell,r0);
    e.Add_St_Venant_Kirchhoff_Hencky_Strain(1e3*e.unit_p*e.scale_E,0.3);
    e.particles.F.Fill(DIAGONAL_MATRIX<T,TV::m>(e.extra_T(0),e.extra_T(1)));
    e.Add_Walls(-1,MPM::BC_SEP,0,0*e.m,false);

}
template void Function_80(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_80(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
