//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 98
// full box
template<class T> void Function_98(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    RANGE<TV> box(e.grid.dX*(T)2,TV::All_Ones_Vector()*e.m-e.grid.dX*2);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(box,0,0,density,e.particles_per_cell,r0);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
}
template void Function_98(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_98(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
