//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 99
// single particle
template<class T> void Function_99(STANDARD_TESTS_BASE<VECTOR<T,2> >& e)
{
    typedef VECTOR<T,2> TV;
    typedef VECTOR<int,2> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    T volume=e.grid.dX.Product()/e.particles_per_cell;
    T mass=density*volume;
    e.Add_Particle(TV(.8,.5),0,0,mass,volume,r0);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8));
}
template void Function_99(STANDARD_TESTS_BASE<VECTOR<float,2> >& e);
template void Function_99(STANDARD_TESTS_BASE<VECTOR<double,2> >& e);
}
