//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 20
template<class T> void Function_20(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    e.Add_Walls(-1,MPM::BC_SEP,.3,0,false);
    T density=4*e.unit_rho*e.scale_mass;
    SPHERE<TV> sphere(TV(.1,.8,.5)*e.m,.06*e.m);
    e.Seed_Particles(sphere,[&e](const TV& X){return TV(.6*(e.m/e.s),0,0);},0,
        density,e.particles_per_cell,r0);
    e.Add_Neo_Hookean(e.unit_p*e.scale_E,0.425);
    e.Add_Collision_Object(SPHERE<TV>(TV(.5,.5,.5)*e.m,.2*e.m),MPM::BC_SEP,.3);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-1.8,0));
}
template void Function_20(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_20(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
