//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 30
// (fluid test) pool of water 
template<class T> void Function_30(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    RANGE<TV> box(TV(0,0,0)*e.m,TV(1,0.25,1)*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(box,0,[&e](const TV&){return MATRIX<T,3>();},density,e.particles_per_cell,r0);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-9.8,0));
}
template void Function_30(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_30(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
