//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 31
// (fluid test) circle drop 
template<class T> void Function_31(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Unit_Box()*e.m);
    e.Add_Walls(-1,MPM::BC_SEP,1,0,false);
    SPHERE<TV> sphere(TV(.5,.75,.5)*e.m,.2*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    e.Seed_Particles(sphere,0,[&e](const TV&){return MATRIX<T,3>();},density,e.particles_per_cell,r0);
    e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-9.8,0));
}
template void Function_31(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_31(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
