//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 44
// sand falling into a pile.
template<class T> void Function_44(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    if(e.extra_T.m<=0) e.extra_T.Append(0);
    if(e.extra_T.m<=1) e.extra_T.Append(0);
    e.particles.Store_Fp(true);
    e.Set_Grid(RANGE<TV>(TV(-.08,0,-.08)*e.m,TV(.08,.06,.08))*e.m,IV(8,3,8),IV(),4);
    RANGE<TV> ground(TV(-10,-10,-10)*e.m,TV(10,0,10)*e.m);
    if(e.reflection_bc) e.Add_Walls(0x37,MPM::BC_SEP,.3,.025*e.m,false);
    else if(e.use_penalty_collisions) e.Add_Penalty_Collision_Object(ground);
    else e.Add_Collision_Object(ground,MPM::BC_NOSLIP,0);
    T E=35.37e6*e.unit_p*e.scale_E,nu=.3;
    if(!e.no_implicit_plasticity) e.use_implicit_plasticity=true;
    e.Add_Drucker_Prager(E,nu,e.extra_T(0));
    TV spout(0,.06*e.m,0);
    T density=(T)2200*e.unit_rho*e.scale_mass;
    T spout_width=0.008334*e.m;
    T pour_speed=.16319*e.m/e.s;
    TV gravity=TV(0,-9.8*e.m/(e.s*e.s),0);
    e.Add_Source(spout,TV(0,-1,0),spout_width/2,pour_speed,gravity,
        density,E,nu,(T)0.08,e.extra_T(1),r0);
    e.Set_Lame_On_Particles(E,nu);
    e.Add_Gravity(gravity);

}
template void Function_44(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_44(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
