//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 49
template<class T> void Function_49(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    if(e.extra_T.m<=0) e.extra_T.Append(0);
    e.Set_Grid(RANGE<TV>(TV(0,0,0),TV(1,1,1))*e.m,IV(1,1,1));
    T init_vel=1*e.m/e.s;
    T E=1e3*e.unit_p*e.scale_E,nu=.3;
    TV gravity(0,-1.8*e.m/(e.s*e.s),0);
    T density=100*e.unit_rho*e.scale_mass;
    e.no_mu=true;
    e.Add_Source(TV(.1,.85-e.extra_T(0),.5)*e.m,TV(1,0,0),e.extra_T(0)*e.m,init_vel,
        gravity,density,E,nu,0,5,r0);
    e.Add_Source(TV(.9,.85-e.extra_T(0),.5)*e.m,TV(-1,0,0),e.extra_T(0)*e.m,init_vel,
        gravity,density,E,nu,0,5,r0);
    e.Add_Gravity(gravity);
    e.Add_Fixed_Corotated(E,nu);
    e.Add_Walls(-1,MPM::BC_SLIP,.3,.025*e.m,false);

}
template void Function_49(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_49(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
