//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 77
// vibrational test
template<class T> void Function_77(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m);
    SPHERE<TV> sphere(TV()*e.m,.6*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    T eps=1.001;
    DIAGONAL_MATRIX<T,3> D(eps,1/eps,1/eps);
    e.Seed_Particles(sphere,0,0,density,e.particles_per_cell,r0);
    e.particles.F.Fill(D);
    for(auto&x:e.particles.X) x=D*x;
    e.Add_St_Venant_Kirchhoff_Hencky_Strain(1e3*e.unit_p*e.scale_E,0.3);
}
template void Function_77(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_77(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
