//#####################################################################
// Copyright 2021, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Geometry/Basic_Geometry/SPHERE.h>
#include "../STANDARD_TESTS_BASE.h"
namespace PhysBAM{
// TEST-NAME 78
// vibrational test
template<class T> void Function_78(STANDARD_TESTS_BASE<VECTOR<T,3> >& e)
{
    typedef VECTOR<T,3> TV;
    typedef VECTOR<int,3> IV;
    REGION_ID r0(0);
    if(e.extra_T.m<=0) e.extra_T.Append(2);
    if(e.extra_T.m<=1) e.extra_T.Append(.5);
    if(e.extra_T.m<=2) e.extra_T.Append(.5);
    e.Set_Grid(RANGE<TV>::Centered_Box()*e.m*(T)10);
    SPHERE<TV> sphere(TV()*e.m,.6*e.m);
    T density=2*e.unit_rho*e.scale_mass;
    DIAGONAL_MATRIX<T,3> D(e.extra_T(0),e.extra_T(1),e.extra_T(2));
    e.Seed_Particles(sphere,0,0,density,e.particles_per_cell,r0);
    e.particles.F.Fill(D);
    for(auto&x:e.particles.X) x=D*x;
    e.Add_St_Venant_Kirchhoff_Hencky_Strain(1e3*e.unit_p*e.scale_E,0.3);
//            e.Add_Gravity(e.m/(e.s*e.s)*TV(0,-9.8,0));
//            e.Add_Walls(-1,MPM::BC_SEP,.3,.1*e.m,false);
}
template void Function_78(STANDARD_TESTS_BASE<VECTOR<float,3> >& e);
template void Function_78(STANDARD_TESTS_BASE<VECTOR<double,3> >& e);
}
