#!/bin/bash

(
    DIR=out_1Bscheme
    mkdir -p ${DIR}

    (
        source common-func.sh
        CMD="../mpm 131singleparticle -explicit -order 2 -T .499999 -T .499999 -no_C_bound -no_cfl_F -resolution 6 -last_frame 100 -write_save_velocity"

        run_3() {
            ns=$1
            CMDE="$CMD -num_substeps $ns"
            $CMDE -o ${DIR}/${ns}_pic -no_affine &
            $CMDE -o ${DIR}/${ns}_apic -affine &
            $CMDE -o ${DIR}/${ns}_cpic -cpic &
        }

        # all fail
        run_3 16

        # both apic pic fail
        run_3 18


        # only pic fail
        run_3 25

        # all stable
        run_3 31

        wait
    ) | grep "frame"

    (
        source common-func.sh
        renderA2G_indir ${DIR}
        play_videos $DIR
    )
)

