#!/bin/bash

# 4*4 sims
(
    DIR=out_1C1ploccmp
    mkdir -p ${DIR}
    CMD="../mpm 131singleparticle -explicit -single_particle_cfl -cfl_p 1 -order 2  -no_C_bound -no_cfl_F -resolution 6 -last_frame 1000"
    run_4 () {
        ns=$1
        x1=.4999;x2=.4999
        echo mpm $x1 $x2
        $CMD -o ${DIR}/${ns}-$x1$x2 -T $x1 -T $x2 -num_substeps $ns &
        x1=0;x2=0
        echo mpm $x1 $x2
        $CMD -o ${DIR}/${ns}-$x1$x2 -T $x1 -T $x2 -num_substeps $ns &
        x1=0;x2=.499999
        echo mpm $x1 $x2
        $CMD -o ${DIR}/${ns}-$x1$x2 -T $x1 -T $x2 -num_substeps $ns &
        x1=.25;x2=.25
        echo mpm $x1 $x2
        $CMD -o ${DIR}/${ns}-$x1$x2 -T $x1 -T $x2 -num_substeps $ns &
    }

    (
    # all fail
    run_4 16

    echo -e "\n" 18
    # only 0,0 not fail
    run_4 18

    echo -e "\n" 20
    # 0,0 .25.25 not fail
    run_4 20

    echo -e "\n" 21
    # only .5.5 fail
    run_4 22

    echo -e "\n" 24
    # only .5.5 fail
    run_4 24

    echo -e "\n" 25
    # no fail
    run_4 25
    wait
    ) | grep frame

    (
        source common-func.sh
        renderA2G_indir ${DIR}
        play_videos $DIR
    )
)
# the dt is less than single_particle_cfl which is .68
# scatter plot octave shows that worst position is .5.5 But analysis shows not, maybe related to end frame timestep


# DIR=out_1C1ploccmp/; source common-func.sh; play_videos $DIR
