#!/bin/bash

(
    DIR=out_1D1pspline
    mkdir -p ${DIR}
    (
    CMD3="../mpm 131singleparticle -explicit -order 3 -T .4 -T .4 -no_C_bound -no_cfl_F -resolution 6 -last_frame 1000 -write_save_velocity"
    CMD2="../mpm 131singleparticle -explicit -order 2 -T .4 -T .4 -no_C_bound -no_cfl_F -resolution 6 -last_frame 1000 -write_save_velocity"
    # unstable ns=16 o3 stable
    $CMD3 -o ${DIR}/1p15o3X.4.4 -num_substeps 15 &
    $CMD2 -o ${DIR}/1p15o2X.4.4 -num_substeps 15 &

    # o3 stable and o2 unstable
    $CMD3 -o ${DIR}/1p20o3X.4.4 -num_substeps 20 &
    $CMD2 -o ${DIR}/1p20o2X.4.4 -num_substeps 20 &

    # stable
    $CMD3 -o ${DIR}/1p25o3X.4.4 -num_substeps 25 &
    $CMD2 -o ${DIR}/1p25o2X.4.4 -num_substeps 25 &
    wait) | grep frame

    (
        source common-func.sh
        renderA2G_indir ${DIR}
        play_videos $DIR
    )
)

