from PIL import Image
import subprocess
import numpy as np
from multiprocessing import Pool
from colour import Color

imsize=256

apic_sound_dt=0.009130447862736485
apic_1p_dt=0.005401645839721239
cpic_sound_dt=0.009130447862736485
cpic_1p_dt=0.007639080805669982
pic_sound_dt=0.009130447275776929
pic_1p_dt=0.004410425359514867

def get_pixel(idx,dts,scheme):
    dt1,dt2=dts
    print(idx,dts)
    CMD="nice ../mpm 131matrix-mixeddt {} -T {} -T {} -E 1e6 -nu .3 -resolution 6 -explicit -suppress_output".format(scheme,dt1,dt2)
    print(CMD)
    out=()
    trys=100
    startc=Color("green")
    colors=list(startc.range_to(Color("darkred"),trys+1))
    cnt=0
    for k in range(trys):
        result=subprocess.run(CMD,shell=True,stderr=subprocess.DEVNULL,stdout=subprocess.PIPE)
        output=result.stdout.decode('utf-8')
        if "FINISHED" not in output:
            print("FAIL")
            cnt+=1
        # else:
        #     out=(idx,(255,255,255))
    c=tuple([int(i*256) for i in colors[cnt].rgb ])
    out=(idx,c)
    return out


def get_img(scheme,max_dt,mul):
    max_dt=max_dt*mul
    im=Image.new(mode="RGB",size=(imsize,imsize),color="white")
    dtrange=np.linspace(1e-7,max_dt,imsize)
    with Pool(64) as p2:
        res=p2.starmap(get_pixel,[((i,j),(dt1,dt2),scheme) for i,dt1 in enumerate(dtrange) for j,dt2 in enumerate(dtrange)] )
        for tup in res:
            idx,color=tup
            im.putpixel(idx,color)

    # im.show()
    im.save(scheme+str(mul)+".png")



mul=1.0000
get_img('-affine',apic_1p_dt,mul)
get_img('-no_affine',pic_1p_dt,mul)
get_img('-cpic',cpic_1p_dt,mul)

# exit()

mul=2
get_img('-affine',apic_1p_dt,mul)
get_img('-no_affine',pic_1p_dt,mul)
get_img('-cpic',cpic_1p_dt,mul)
