#!/usr/bin/perl -w
require strict;
use File::Path "remove_tree";

# TODO node_velocity.gz needs another parse file other than dump_particle
# TODO fix 11shell
# TODO fix 1p stability range
my $D=$ARGV[0];
if (substr($D, -1) eq "/") {
    chop $D;
}
my $OD="${D}_tex";
my $PB=$ENV{'PHYSBAM'};
my $DP="$PB/Tools/dump_particle/dump_particle";
my $DG="$PB/Tools/dump_particle/dump_grid";

my $max_v=.3;

remove_tree($OD);
mkdir($OD);

my ($ux,$uy,$x,$y);

my $f=0;
my $p=0;
open $Omag, ">$OD/magnitude_evaluation.m";
printf $Omag "C={};\n";
printf $Omag "F={};\n";
while ( -e "$D/$f/mpm_particles.gz" ) {
    my $n=sprintf("%04d",$f);
    open O, ">$OD/$n.tex";

    print O <<'EOF';
\documentclass[tikz]{standalone}
\begin{document}
\begin{tikzpicture}[scale=10]
\clip (-.01,-.01) rectangle (1.01,1.01);
\draw[thick] (-.01,-.01) rectangle (1.01,1.01);
\draw[draw=white,opacity=0] (-.02,-.02) rectangle (1.02,1.02);
EOF

    my $data=`$DP $D/$f/mpm_particles.gz`;
    for (split '\n',$data) {
        if (/V = \((.*) (.*)\)/) {
            $ux=$1;$uy=$2;
        }
        if (/X = \((.*) (.*)\)/) {
            $x=$1;
            $y=$2;
            my $m=sqrt($ux*$ux+$uy*$uy); # 2d velocity
            my $p=$m*6/$max_v+1;         # v*6/4+1
            # print "m $m p $p\n";
            $c="red";
            if (--$p<1) {
                $c=sprintf("blue!%.2f!black",$p*100);
            } elsif (--$p<1) {
                $c=sprintf("cyan!%.2f!blue",$p*100);
            } elsif (--$p<1) {
                $c=sprintf("green!%.2f!cyan",$p*100);
            } elsif (--$p<1) {
                $c=sprintf("yellow!%.2f!green",$p*100);
            } elsif (--$p<1) {
                $c=sprintf("red!%.2f!yellow",$p*100);
            } elsif (--$p<1) {
                $c=sprintf("red!%.2f!red",$p*100);
            }
            printf O "\\draw[draw=none,fill=$c] (%.4f,%.4f) circle (.005);\n",$x,$y;
            printf O "\\draw[-to,red](${x},${y}) -- (%.4f,%.4f);\n",$x+$ux,$y+$uy;
        }
        if (/C = (\[.*\])/) {
            $p++;printf $Omag "C(${f}+1,$p)=${1};\n";
        }
        if (/F = (\[.*\])/) {
            printf $Omag "F(${f}+1,$p)=${1};\n";
        }
    }
    my $grid_data=`$DP $D/$f/node_velocities.gz`;

    print O <<'EOF';
\end{tikzpicture}
\end{document}
EOF

    close O;
    system("( cd $OD ; pdflatex -halt-on-error $n.tex > /dev/null ; convert -density 175.6 $n.pdf $n.png ; echo render $n ) &");
    print "emit $n\n";
    $f++;
    $p=0;
}

# velocity half size; TODO for single particle
# TODO png to mov
print 'ffmpeg -y -i $OD/%04d.png -pix_fmt yuv420p -vcodec libx264 -vf "pad=ceil(iw/2)*2:ceil(ih/2)*2" -b:v 4096k $OD/output.mp4'
# print `ffmpeg -y -i $OD/%04d.png -pix_fmt yuv420p -vcodec libx264 -vf "pad=ceil(iw/2)*2:ceil(ih/2)*2" -b:v 4096k $OD/output.mp4`
# exec {'/bin/bash'} 'source ~/.bashrc; make_mov $OD/%04d.png $OD/output.mp4'
