#!/bin/bash

(
    RENDER=$PHYSBAM/Tools/dump_particle/render_sim_2d

    COL='uu=-.4*(y-.5);vv=.4*(x-.5);du=u-uu;dv=v-vv;m=sqrt(du*du+dv*dv);r=m*30;g=0;b=0;'
    for s in out_2A1test-r-nu-cfl/output-.3-.3-.9 ; do
        $RENDER -i $s -clip '0 0 1 1' -use_part -part_size .003 -part_v_scale .5 -part_v_arrow -part_v_col_prog "$COL" -part_col_prog "$COL" &
#        break
    done
    wait
    echo Finished generating latex files

    for s in out_2A1test-r-nu-cfl/output-.3-.3-.9/tex ; do
        (
            cd $s
            basename -s .tex frame-*.tex | xargs -n 1 -P 32 -I@ -- bash -c "pdflatex -halt-on-error @.tex >/dev/null ; convert -density 175.6 -resize 720 -background '#c0c0c0' -flatten @.pdf @.png"
            ffmpeg -y -i frame-%04d.png -pix_fmt yuv420p -vcodec libx264 -b 4096k movie.mov
            echo Finished rendering $s
        )
#        break
    done
)
