#!/bin/bash


rm -f forward.txt
rm -f hash-2d.txt
rm -f hash-3d.txt
rm -f hash-nd.txt

for d in 2 3 n ; do
    L=`( cd "$d"d ; ls *.cpp | sort -n )`
    for l in $L ; do
        f="$d"d/$l
        D=`grep '(STANDARD_TESTS_BASE' $f | head -n 1`
        echo $D
        echo "$D;" >> forward.txt
        F=`echo $D | sed 's/(STANDARD_TESTS_BASE.*//' | sed 's/.* //'`
        for n in `grep TEST-NAME $f | sed 's/.*TEST-NAME *//'` ; do
            echo '        test_list.Set("'$n'",&'$F');' >> hash-"$d"d.txt
        done
    done
done

cat > TEST_LIST.cpp <<EOF
//#####################################################################
// Copyright 2015, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Core/Data_Structures/HASHTABLE.h>
#include <Core/Vectors/VECTOR.h>
#include <string>
namespace PhysBAM{
template<class TV> class STANDARD_TESTS_BASE;

EOF

cat forward.txt >> TEST_LIST.cpp

cat >> TEST_LIST.cpp <<EOF

template<class TV>
void Collect_Tests(HASHTABLE<std::string,void(*)(STANDARD_TESTS_BASE<TV>&)>& test_list)
{
    if constexpr(TV::m==2)
    {
EOF

cat hash-2d.txt >> TEST_LIST.cpp
cat hash-nd.txt >> TEST_LIST.cpp

cat >> TEST_LIST.cpp <<EOF
    }
    else
    {
EOF

cat hash-3d.txt >> TEST_LIST.cpp
cat hash-nd.txt >> TEST_LIST.cpp

cat >> TEST_LIST.cpp <<EOF
    }
}
template void Collect_Tests<VECTOR<double,2> >(HASHTABLE<std::string,
    void(*)(STANDARD_TESTS_BASE<VECTOR<double,2> >&)>&);
template void Collect_Tests<VECTOR<double,3> >(HASHTABLE<std::string,
    void(*)(STANDARD_TESTS_BASE<VECTOR<double,3> >&)>&);
template void Collect_Tests<VECTOR<float,2> >(HASHTABLE<std::string,
    void(*)(STANDARD_TESTS_BASE<VECTOR<float,2> >&)>&);
template void Collect_Tests<VECTOR<float,3> >(HASHTABLE<std::string,
    void(*)(STANDARD_TESTS_BASE<VECTOR<float,3> >&)>&);
}
EOF

rm -f forward.txt
rm -f hash-2d.txt
rm -f hash-3d.txt
rm -f hash-nd.txt
