#include <Core/Math_Tools/Spline_Interpolation.h>
namespace PhysBAM{

// num, abs(index-clamped_index)-1, out-index, coeff-power(0..3)
int spline_coeff_table_L[5][4][4][4]=
{
    {
        {{4,0,-6,3},{1,3,3,-3},{0,0,0,1}},
        {{1,3,3,-3},{0,0,0,1}},
        {{0,0,0,1}},
        {{}}
    },
    {
        {{5,-3,-3,2},{1,3,3,-3},{0,0,0,1}},
        {{6,0,0,-1},{0,0,0,1}},
        {{6}},{{6}}
    },
    {
        {{6,-6,0,1},{0,6,0,-2},{0,0,0,1}},
        {{12,-6},{-6,6}},
        {{18,-6},{-12,6}},
        {{24,-6},{-18,6}}
    },
    {
        {{7,-9,3},{-2,12,-6},{1,-3,3}},
        {{19,-15,3},{-20,24,-6},{7,-9,3}},
        {{37,-21,3},{-50,36,-6},{19,-15,3}},
        {{61,-27,3},{-92,48,-6},{37,-21,3}}
    },
    {
        {{8,-12,6,-1},{-5,21,-15,3},{4,-12,12,-3},{-1,3,-3,1}},
        {{27,-27,9,-1},{-44,60,-24,3},{31,-45,21,-3},{-8,12,-6,1}},
        {{64,-48,12,-1},{-131,117,-33,3},{100,-96,30,-3},{-27,27,-9,1}},
        {{125,-75,15,-1},{-284,192,-42,3},{229,-165,39,-3},{-64,48,-12,1}}
    }
};

int spline_coeff_table_L_fixed[4][4]=
{
    {1,-3,3,-1},
    {5,-3,-3,2},
    {6,0,0,-1},
    {6,0,0,0},
};
int spline_coeff_table_R[5][4][4][4]=
{
    {
        {{},{1,-3,3,-1},{4,0,-6,3},{1,3,3,-3}},
        {{},{},{1,-3,3,-1},{4,0,-6,3}},
        {{},{},{},{1,-3,3,-1}},
        {{},{},{},{}}
    },
    {
        {{},{1,-3,3,-1},{4,0,-6,3},{1,3,3,-2}},
        {{},{},{1,-3,3,-1},{5,3,-3,1}},
        {{},{},{},{6}},
        {{},{},{},{6}}
    },
    {
        {{},{1,-3,3,-1},{4,0,-6,2},{1,3,3,-1}},
        {{},{},{0,-6},{6,6}},
        {{},{},{-6,-6},{12,6}},
        {{},{},{-12,-6},{18,6}}
    },
    {
        {{},{1,-3,3},{4,0,-6},{1,3,3}},
        {{},{1,3,3},{-2,-12,-6},{7,9,3}},
        {{},{7,9,3},{-20,-24,-6},{19,15,3}},
        {{},{19,15,3},{-50,-36,-6},{37,21,3}}
    },
    {
        {{0,0,0,-1},{1,-3,3,3},{4,0,-6,-3},{1,3,3,1}},
        {{-1,-3,-3,-1},{4,12,12,3},{-5,-21,-15,-3},{8,12,6,1}},
        {{-8,-12,-6,-1},{31,45,21,3},{-44,-60,-24,-3},{27,27,9,1}},
        {{-27,-27,-9,-1},{100,96,30,3},{-131,-117,-33,-3},{64,48,12,1}}
    }};

int spline_coeff_table_R_fixed[4][4]=
{
    {0,0,0,1},
    {1,3,3,-2},
    {5,3,-3,1},
    {6,0,0,0},
};
}
