//#####################################################################
// Copyright 2003-2009, Zhaosheng Bao, Ronald Fedkiw, Geoffrey Irving, Igor Neverov, Craig Schroeder, Andrew Selle, Tamar Shinar, Eftychios Sifakis, Jonthan Su.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class DEFORMABLE_BODY_COLLECTION
//#####################################################################
#ifndef __DEFORMABLE_BODY_COLLECTION__
#define __DEFORMABLE_BODY_COLLECTION__

#include <Core/Arrays/ARRAY.h>
#include <Core/Read_Write/READ_WRITE_FUNCTIONS.h>
#include <Core/Utilities/Find_Type.h>
namespace PhysBAM{

template<class TV> class DEFORMABLE_PARTICLES;
template<class TV> class STRUCTURE;
struct VIEWER_DIR;

template<class TV>
class DEFORMABLE_BODY_COLLECTION
{
    typedef typename TV::SCALAR T;
public:
    DEFORMABLE_PARTICLES<TV>& particles;
    ARRAY<STRUCTURE<TV>*> structures;

    int Add_Structure(STRUCTURE<TV>* structure)
    {return structures.Append(structure);}

    template<class T_STRUCTURE> T_STRUCTURE
    Find_Structure(const int index=0)
    {return Find_Type<T_STRUCTURE>(structures,index);}

    template<class T_STRUCTURE> const T_STRUCTURE
    Find_Structure(const int index=0) const
    {return Find_Type<T_STRUCTURE>(structures,index);}

    bool own_particles;

    DEFORMABLE_BODY_COLLECTION(DEFORMABLE_PARTICLES<TV>* particles=0);
    DEFORMABLE_BODY_COLLECTION(const DEFORMABLE_BODY_COLLECTION&) = delete;
    void operator=(const DEFORMABLE_BODY_COLLECTION&) = delete;
    virtual ~DEFORMABLE_BODY_COLLECTION();

//#####################################################################
    void Read_Static_Variables(const VIEWER_DIR& viewer_dir);
    void Write_Static_Variables(const STREAM_TYPE stream_type,const VIEWER_DIR& viewer_dir,bool static_variables_every_frame) const;
    void Read_Dynamic_Variables(const VIEWER_DIR& viewer_dir);
    void Write_Dynamic_Variables(const STREAM_TYPE stream_type,const VIEWER_DIR& viewer_dir) const;

    void Read(const VIEWER_DIR& viewer_dir,const bool read_static_variables);
    void Write(const STREAM_TYPE,const VIEWER_DIR& viewer_dir,const bool static_variables_every_frame,const bool write_from_every_process=true) const;
//#####################################################################
};
}
#endif
