//#####################################################################
// Copyright 2004-2008, Ron Fedkiw, Geoffrey Irving, Andrew Selle.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <Deformables/Deformable_Objects/DEFORMABLE_PARTICLES.h>
#include <Core/Math_Tools/Robust_Arithmetic.h>
#include <Core/Read_Write/FILE_UTILITIES.h>
#include <Core/Vectors/VECTOR.h>
namespace PhysBAM{
//#####################################################################
// Constructor
//#####################################################################
template<class TV> DEFORMABLE_PARTICLES<TV>::
DEFORMABLE_PARTICLES()
    :mass(0,0),one_over_mass(0,0),effective_mass(0,0),one_over_effective_mass(0,0),store_mass(false)
{
}
//#####################################################################
// Constructor
//#####################################################################
template<class TV> DEFORMABLE_PARTICLES<TV>::
~DEFORMABLE_PARTICLES()
{}
//#####################################################################
// Function Center_Of_Mass
//#####################################################################
template<class TV> TV DEFORMABLE_PARTICLES<TV>::
Center_Of_Mass() const
{
    if(this->store_mass){
        T total=mass.Sum();
        return total?X.Weighted_Sum(mass)/total:TV();}
    return X.Average(); // default to treating mass as one
}
//#####################################################################
template class DEFORMABLE_PARTICLES<VECTOR<float,1> >;
template class DEFORMABLE_PARTICLES<VECTOR<float,2> >;
template class DEFORMABLE_PARTICLES<VECTOR<float,3> >;
template class DEFORMABLE_PARTICLES<VECTOR<double,1> >;
template class DEFORMABLE_PARTICLES<VECTOR<double,2> >;
template class DEFORMABLE_PARTICLES<VECTOR<double,3> >;
}
