//#####################################################################
// Copyright 2002-2005, Ronald Fedkiw, Geoffrey Irving, Joseph Teran.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class HEXAHEDRON
//##################################################################### 
#ifndef __HEXAHEDRON__
#define __HEXAHEDRON__

#include <Core/Vectors/VECTOR_3D.h>
namespace PhysBAM{

template<class T>
class HEXAHEDRON
{
    typedef VECTOR<T,3> TV;
public:
    TV x0,x1,x2,x3,x4,x5,x6,x7; 
    
    HEXAHEDRON();
    HEXAHEDRON(const TV& x1,const TV& x2,const TV& x3,const TV& x4,
        const TV& x5,const TV& x6,const TV& x7,const TV& x8);
//#####################################################################
    static T Volume(const TV& x0,const TV& x1,const TV& x2,const TV& x3,
        const TV& x4,const TV& x5,const TV& x6,const TV& x7);
    static T Signed_Volume(const TV& x0,const TV& x1,const TV& x2,const TV& x3,
        const TV& x4,const TV& x5,const TV& x6,const TV& x7);
    T Volume() const;
    T Signed_Volume() const;
//#####################################################################
};   

template<class T,class TV> HEXAHEDRON<T> Scaled(const HEXAHEDRON<T>& b,const TV& center,T scale);
template<class T,class TV> HEXAHEDRON<T> Transformed(const HEXAHEDRON<T>& b,const FRAME<TV>& f);
}
#endif
