//#####################################################################
// Copyright 2009, Jon Gretarsson.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// namespace TESSELLATION
//##################################################################### 
#include <Geometry/Basic_Geometry/RANGE_TESSELLATION.h>
#include <Core/Math_Tools/RANGE.h>
#include <Geometry/Meshes/TRIANGULATED_SURFACE.h>

namespace PhysBAM{
//#####################################################################
// Function Generate_Triangles
//#####################################################################
template<class T> TRIANGULATED_SURFACE<T>* Generate_Triangles(
    const RANGE<VECTOR<T,3> >& box,const VECTOR<int,3>& res)
{
    TRIANGULATED_SURFACE<T>* surface=TRIANGULATED_SURFACE<T>::Create();
    surface->Initialize_Box_Mesh_And_Particles(res,box);
    return surface;
}
//#####################################################################
template TRIANGULATED_SURFACE<float>* Generate_Triangles(
    const RANGE<VECTOR<float,3> >&,const VECTOR<int,3>&);
template TRIANGULATED_SURFACE<double>* Generate_Triangles(
    const RANGE<VECTOR<double,3> >&,const VECTOR<int,3>&);
}
