//#####################################################################
// Copyright 2009, Jon Gretarsson.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class LEVELSET_UTILITIES
//#####################################################################
#ifndef __LEVELSET_UTILITIES__
#define __LEVELSET_UTILITIES__

#include <Core/Math_Tools/constants.h>
#include <Core/Vectors/SCALAR_POLICY.h>
#include <cassert>
#include <cfloat>
namespace PhysBAM{

template<class T>
class LEVELSET_UTILITIES
{
    STATIC_ASSERT((is_same<SCALAR_TYPE<T>,T>::value));
protected:
    LEVELSET_UTILITIES() = delete;
    ~LEVELSET_UTILITIES() = delete;

public:
    static T Sign(const T phi)
    {if(phi <= 0) return -1;else return 1;}

    static bool Interface(const T phi_1,const T phi_2)
    {return (phi_1 > 0 && phi_2 <=0) || (phi_1 <= 0 && phi_2 > 0);}

    static T Theta(const T phi_left,const T phi_right)
    {assert(phi_left!=phi_right);return phi_left/(phi_left-phi_right);}

//#####################################################################
};
}
#endif
