//#####################################################################
// Copyright 2004-2009, Eran Guendelman, Geoffrey Irving, Andrew Selle.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class OPENGL_GRID_BASED_VECTOR_FIELD_2D
//#####################################################################
#ifndef __OPENGL_GRID_BASED_VECTOR_FIELD_2D__
#define __OPENGL_GRID_BASED_VECTOR_FIELD_2D__

#include <Core/Arrays_Nd/ARRAYS_ND.h>
#include <Core/Vectors/VECTOR_2D.h>
#include <Grid_Tools/Grids/GRID.h>
#include <OpenGL/OpenGL/OPENGL_GRID_OBJECT.h>
#include <OpenGL/OpenGL/OPENGL_VECTOR_FIELD_2D.h>
namespace PhysBAM{

template<class T>
class OPENGL_GRID_BASED_VECTOR_FIELD_2D:public OPENGL_VECTOR_FIELD_2D<ARRAY<VECTOR<T,2> > >,public OPENGL_GRID_OBJECT<VECTOR<T,2> >
{
    typedef VECTOR<T,2> TV;typedef VECTOR<int,2> IV;
public:
    using OPENGL_VECTOR_FIELD_2D<ARRAY<TV> >::size;using OPENGL_OBJECT<T>::World_Space_Box;

    ARRAY<TV> vector_field,vector_locations;
    GRID<TV> grid;
    ARRAY<TV,IV>& V;

    OPENGL_GRID_BASED_VECTOR_FIELD_2D(const GRID<TV>& grid,ARRAY<VECTOR<T,2>,VECTOR<int,2> >& V);
    virtual ~OPENGL_GRID_BASED_VECTOR_FIELD_2D();

    void Update();  // Call when grid/V change

    virtual RANGE<VECTOR<T,3> > Bounding_Box() const override;
    void Print_Cell_Selection_Info(std::ostream& stream,const IV& cell) const override;
    void Print_Node_Selection_Info(std::ostream& stream,const IV& node) const override;
};
}
#endif
