//#####################################################################
// Copyright 2004, Geoffrey Irving.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <OpenGL/OpenGL_Components/OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D.h>
#include <Core/Matrices/MATRIX_2X2.h>
#include <Core/Utilities/VIEWER_DIR.h>
using namespace PhysBAM;
//#####################################################################
// Destructor
//#####################################################################
template<class T> OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
~OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D()
{
}
//#####################################################################
// Function Reinitialize
//##################################################################### 
template<class T> void OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Reinitialize()
{
    if(!draw) return;
    valid=false;std::string tmp_filename=viewer_dir.Frame_File(field_filename);
    if(File_Exists(tmp_filename))
        Read_From_File(tmp_filename,field);
    else return;
    opengl_symmetric_matrix_field.Update();
    valid=true;
}
//#####################################################################
// Function Set_Frame
//#####################################################################
template<class T> void OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Set_Frame()
{
    Reinitialize();
}
//#####################################################################
// Function Set_Draw
//#####################################################################
template<class T> void OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Set_Draw(bool draw_input)
{
    OPENGL_COMPONENT<T>::Set_Draw(draw_input);
    Reinitialize();
}
//#####################################################################
// Function Display
//#####################################################################
template<class T> void OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Display() const
{
    if(valid&&draw)
        opengl_symmetric_matrix_field.Display();
}
//#####################################################################
// Function Use_Bounding_Box
//#####################################################################
template<class T> bool OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Use_Bounding_Box() const
{
    return draw&&valid;
}
//#####################################################################
// Function Bounding_Box
//#####################################################################
template<class T> auto OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<T>::
Bounding_Box() const -> RANGE<VECTOR<T,3> > 
{
    if(valid&&draw)
        return opengl_symmetric_matrix_field.Bounding_Box();
    return RANGE<VECTOR<T,3> >::Centered_Box();
}
//##################################################################### 
namespace PhysBAM{
template class OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<float>;
template class OPENGL_COMPONENT_SYMMETRIC_MATRIX_FIELD_2D<double>;
}
