//#####################################################################
// Copyright 2003-2007, Zhaosheng Bao, Ronald Fedkiw, Geoffrey Irving, Igor Neverov, Andrew Selle, Tamar Shinar, Eftychios Sifakis.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class SOLID_BODY_COLLECTION
//#####################################################################
#ifndef __SOLID_BODY_COLLECTION__
#define __SOLID_BODY_COLLECTION__

#include <Core/Utilities/Find_Type.h>
#include <Deformables/Deformable_Objects/DEFORMABLE_PARTICLES.h>
namespace PhysBAM{

template<class TV> class DEFORMALBLE_OBJECT_COLLISIONS;
template<class TV> class RIGID_BODY_COLLECTION;
template<class TV> class DEFORMABLE_BODY_COLLECTION;
struct VIEWER_DIR;

template<class TV>
class SOLID_BODY_COLLECTION
{
    typedef typename TV::SCALAR T;
    typedef typename TV::SPIN T_SPIN;
public:
    DEFORMABLE_BODY_COLLECTION<TV>& deformable_body_collection;
    RIGID_BODY_COLLECTION<TV>& rigid_body_collection;

    SOLID_BODY_COLLECTION(DEFORMABLE_PARTICLES<TV>* particles=0);
    SOLID_BODY_COLLECTION(const SOLID_BODY_COLLECTION&) = delete;
    void operator=(const SOLID_BODY_COLLECTION&) = delete;
    virtual ~SOLID_BODY_COLLECTION();

//#####################################################################
    void Read(const VIEWER_DIR& viewer_dir,const bool static_variables_every_frame=false,
        ARRAY<int>* needs_init=0,ARRAY<int>* needs_destroy=0);
    void Write(const STREAM_TYPE stream_type,const VIEWER_DIR& viewer_dir,const bool static_variables_every_frame=false,const bool write_from_every_process=true) const;
//#####################################################################
};
}
#endif
