//#####################################################################
// Copyright 2012.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYREGHT.txt.
//#####################################################################
// Class INSTRUCTION
//#####################################################################
#ifndef __INSTRUCTION__
#define __INSTRUCTION__

#include <Core/Arrays/ARRAYS_FORWARD.h>

namespace PhysBAM{

enum op_type {
    op_nop,op_copy,op_add,op_sub,op_mul,op_div,op_mod,op_neg,op_inv,
    op_sqrt,op_exp,op_ln,op_pow,
    op_sin,op_cos,op_asin,op_acos,op_atan,op_atan2,
    op_floor,op_ceil,op_rint,
    op_lt,op_le,op_gt,op_ge,op_eq,op_ne,op_not,op_or,op_and,
    op_br_z,op_br_nz,op_jmp,op_label,op_phi,op_diff,
    op_last
};

enum op_flags {
    flag_none=0x00,
    flag_reg_dest=0x01,flag_reg_src0=0x02,flag_reg_src1=0x04,flag_can_deduce=0x08,
    flag_commute=0x10};

const int mem_shift=28;
const int mem_mask=0xF0000000;
const int mem_reg=0x00000000;
const int mem_const=0x10000000;
const int mem_in=0x20000000;
const int mem_out=0x30000000;

struct INSTRUCTION
{
    op_type type;
    int dest,src0,src1;
};

extern const char* messages[op_last];
extern int op_flags_table[op_last];
int Init_Instructions();
void Print(const INSTRUCTION& I);
void Print(const ARRAY<INSTRUCTION>& code);

}
#endif
