//#####################################################################
// Copyright 2012.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYREGHT.txt.
//#####################################################################
// Class PROGRAM
//#####################################################################
#ifndef __PROGRAM__
#define __PROGRAM__

#include <Core/Arrays/ARRAY.h>
#include <Tools/Symbolics/INSTRUCTION.h>
namespace PhysBAM{

template<class T> struct PROGRAM_CONTEXT;

template<class T>
struct PROGRAM
{
    int extra_out=0;
    int num_tmp=0;
    int num_var_in=0;
    int num_var_out=0;
    ARRAY<T> constants;
    ARRAY<INSTRUCTION> code;

    PROGRAM()=default;
    PROGRAM(const PROGRAM& p)=default;

    template<class U,class F>
    PROGRAM(const PROGRAM<U>& p,F f)
        :extra_out(p.extra_out),num_tmp(p.num_tmp),num_var_in(p.num_var_in),
        num_var_out(p.num_var_out),constants(p.constants.m),code(p.code)
    {
        for(int i=0;i<constants.m;i++)
            constants(i)=f(p.constants(i));
    }

    void Execute(ARRAY<T>& reg) const;
    void Execute(PROGRAM_CONTEXT<T>& context) const;
    void Execute_Op(ARRAY<T>& reg,int& ip) const;
    void Print() const;
};

template<class T>
T Evaluate_Op(int type,T in0,T in1);

template<class T> void
Simple_Compile(PROGRAM<T>& prog,const std::string& code,
    const ARRAY<std::string>& var_in,const ARRAY<std::string>& var_out);
}
#endif
