//#####################################################################
// Copyright 2022, Craig Schroeder.
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
// Class SYMBOLIC_NUMBER
//##################################################################### 
#ifndef __SYMBOLIC_NUMBER__
#define __SYMBOLIC_NUMBER__

#include <Tools/Symbolics/SYMBOLIC.h>
#include <string>
namespace PhysBAM{

struct SYMBOLIC_NUMBER:SYMBOLIC_BASE
{
    std::string s;

    SYMBOLIC_NUMBER();
    SYMBOLIC_NUMBER(const std::string& t);
    SYMBOLIC_NUMBER(const SYMBOLIC_NUMBER& t)=default;
    
    ~SYMBOLIC_NUMBER()=default;
    void Cache();
    void Set(double s) override;
    void Print(std::ostream& o,double x) const override;
    
    SYMBOLIC_BASE* copy() const override;
    SYMBOLIC_BASE* pos() const override;
    SYMBOLIC_BASE* neg() const override;
    SYMBOLIC_BASE* add(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* sub(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* mul(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* div(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* abs() const override;
    SYMBOLIC_BASE* inv() const override;
    SYMBOLIC_BASE* sqrt() const override;
    SYMBOLIC_BASE* floor() const override;
    SYMBOLIC_BASE* ceil() const override;
    SYMBOLIC_BASE* rint() const override;
    SYMBOLIC_BASE* exp() const override;
    SYMBOLIC_BASE* log() const override;
    SYMBOLIC_BASE* hypot(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* pow(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* sin() const override;
    SYMBOLIC_BASE* cos() const override;
    SYMBOLIC_BASE* tan() const override;
    SYMBOLIC_BASE* atan2(const SYMBOLIC_BASE* a) const override;
    SYMBOLIC_BASE* asin() const override;
    SYMBOLIC_BASE* acos() const override;
    SYMBOLIC_BASE* atan() const override;
};
}

#endif
